Skip to main content

Create User

POST/users

Creates a user with workspace assignments and returns 201 on success.

Request Body
namestringrequired
Full name of the user.
emailstringrequired
Email address of the user.
passwordstringoptional
Password for the user account. If omitted, an invite email is sent.
statusstringoptional
Initial status of the user. Accepted values: active, invited.
workspacesarrayrequired
List of workspaces to add the user to, each with optional status and group assignments.
Error Responses
400
Missing required fields, email already exists, workspace or group not found, or invalid group type.
402
User count exceeds the license limit.
403
External API disabled, missing EXTERNAL_API license, or invalid Authorization token.
404
Not available on Community Edition.
451
EXTERNAL_API license not available.
Request
curl -X POST "https://{your-domain}/api/ext/users" -H "Authorization: Basic <access_token>" -H "Content-Type: application/json" -d '{
"name": "Alice Johnson",
"email": "[email protected]",
"password": "qwy@4xt123",
"status": "active",
"workspaces": [
  {
    "name": "team-spac",
    "status": "active",
    "groups": [
      {
        "name": "all_users"
      }
    ]
  }
]
}'
Response — 201
{
"id": "2819c223-7f76-453a-919d-413861904646",
"name": "Alice Johnson",
"email": "[email protected]",
"status": "invited",
"workspaces": [
  {
    "id": "b2c3d4e5-f6a7-8901-bcde-f12345678901",
    "name": "team-space",
    "status": "invited",
    "inviteUrl": "https://app.tooljet.com/invitations/<userToken>/workspaces/<orgToken>?oid=<orgId>",
    "userPermission": {}
  }
],
"userGroups": [
  {"id": "c3d4e5f6-a7b8-9012-cdef-123456789012", "name": "all_users"}
],
"userDetails": [
  {"organizationId": "b2c3d4e5-f6a7-8901-bcde-f12345678901", "ssoUserInfo": null, "userMetadata": null}
]
}